<?php 

// 1.Обновляем изменения в бд
$sql = '
BEGIN;

CREATE TABLE "adminer_activated_modules" (
  "id" integer NULL PRIMARY KEY AUTOINCREMENT,
  "name" text NULL,
  "type" text NULL,
  "position" text NULL,
  "back_end" integer NULL DEFAULT "0",
  "sort" integer NULL DEFAULT "1",
  "module_id" integer NULL,
  "module_dir" text NULL,
  "params" text NULL,
  "sections" text NULL,
  "date_edit" integer NULL
);
INSERT INTO "adminer_activated_modules" ("id", "name", "type", "position", "back_end", "sort", "module_id", "module_dir", "params", "date_edit") SELECT "id", "name", "type", "position", "back_end", "sort", "module_id", "module_dir", "params", "date_edit" FROM "activated_modules";
DROP TABLE "activated_modules";
ALTER TABLE "adminer_activated_modules" RENAME TO "activated_modules";

CREATE TABLE "adminer_main" (
  "id" integer NULL PRIMARY KEY AUTOINCREMENT,
  "parent_id" integer NULL DEFAULT "0",
  "name" text NOT NULL,
  "title" text NOT NULL,
  "keywords" text NOT NULL,
  "description" text NOT NULL,
  "component" text NOT NULL,
  "url" text NULL,
  "view" text NULL,
  "theme_view" text NULL,
  "date_add" integer NULL,
  "date_edit" integer NULL
);
INSERT INTO "adminer_main" ("id", "parent_id", "name", "title", "keywords", "description", "component", "url", "date_add", "date_edit") SELECT "id", "parent_id", "name", "title", "keywords", "description", "component", "url", "date_add", "date_edit" FROM "main";
DROP TABLE "main";
ALTER TABLE "adminer_main" RENAME TO "main";

COMMIT;
';

$this->dbh->exec($sql);

// 2. Активируем добавленные дефолтные модули
$this->load_model('component', 'modules_manager');

$redirect_install_data = array(
	'name' => '301 редирект',
	'type' => 'addon',
	'version' => '1.0',
	'dir'     => 'redirect_301',
	'description' => '
Пример: 
/old_url.html|/ne_url.html
/catalog|/katalog
/contacts.html|/kontakty.html'
);

$this->model_component_modules_manager->install_module($redirect_install_data);

$redirect_activate_data = array(
	'name' => '301 редирект',
	'type' => 'addon',
	'module_id' => $this->dbh->lastInsertId(),
	'module_dir' => 'redirect_301',
	'params' => null,
	'sections' => null,
	'position' => 'before', 
	'back_end' => 0, 
	'sort' => 1
);

$this->model_component_modules_manager->activate_module($redirect_activate_data);

$codemirror_install_data = array(
	'name' => 'Редактор кода Codemirror',
	'type' => 'addon',
	'version' => '0.9',
	'dir'     => 'codemirror',
	'description' => 'Codemirror is a versatile text editor implemented in JavaScript for the browser. It is specialized for editing code, and comes with a number of language modes and addons that implement more advanced editing functionaly.'
);

$this->model_component_modules_manager->install_module($codemirror_install_data);

$codemirror_activate_data = array(
	'name' => 'Редактор кода Codemirror',
	'type' => 'addon',
	'module_id' => $this->dbh->lastInsertId(),
	'module_dir' => 'codemirror',
	'params' => null,
	'sections' => null,
	'position' => 'after', 
	'back_end' => 1, 
	'sort' => 1
);

$this->model_component_modules_manager->activate_module($codemirror_activate_data);

//  Главное меню админки
$block_menu = $this->dbh->row("SELECT * FROM installed_modules WHERE type = 'block' AND dir = 'menu' LIMIT 1");

$sql = "INSERT INTO menus (name, class) VALUES ('Главное меню админки', '')";
$this->dbh->exec($sql);
$menu_id = $this->dbh->lastInsertId();

$this->dbh->query("INSERT INTO menus_items (parent_id, menu_id, name, url, sort) 
				VALUES (0, '" . (int)$menu_id . "', 'Страницы', '/admin/pages', 1)");
$this->dbh->query("INSERT INTO menus_items (parent_id, menu_id, name, url, sort) 
				VALUES (0, '" . (int)$menu_id . "', 'Менеджер меню', '/admin/menus_manager', 20)");
$this->dbh->query("INSERT INTO menus_items (parent_id, menu_id, name, url, sort) 
				VALUES (0, '" . (int)$menu_id . "', 'Компоненты', '/admin/components_manager', 30)");
$this->dbh->query("INSERT INTO menus_items (parent_id, menu_id, name, url, sort) 
				VALUES (0, '" . (int)$menu_id . "', 'Модули', '/admin/modules_manager', 40)");
$this->dbh->query("INSERT INTO menus_items (parent_id, menu_id, name, url, sort) 
				VALUES (0, '" . (int)$menu_id . "', 'Настройки', '/admin/config', 50)");
$this->dbh->query("INSERT INTO menus_items (parent_id, menu_id, name, url, sort) 
				VALUES (0, '" . (int)$menu_id . "', 'Пользователи', '/admin/users', 60)");
				
$menu_params = 's:1:"' . $menu_id . '";';
$sql = "INSERT INTO activated_modules (name, type, position, back_end, sort, module_id, module_dir, params, sections, date_edit)
				VALUES ('Главное меню админки', 'block', 'main_menu', 1, 100, '" . (int)$block_menu['id'] . "', 'menu', '" . $this->dbh->escape($menu_params) . "', '', '" . time() . "' )";

				$this->dbh->query($sql);
				
// обновляем сортировку модулей
$sql = '';

$back_results = $this->dbh->query("SELECT * FROM activated_modules WHERE back_end = '1' ORDER BY sort ASC");
$front_results = $this->dbh->query("SELECT * FROM activated_modules WHERE back_end = '0' ORDER BY sort ASC");

foreach ($back_results as $key => $result) {
	$sql .= "UPDATE activated_modules SET sort = '" . ($key+1) . "' WHERE id = '" . (int)$result['id'] . "'; ";
}	
foreach ($front_results as $key => $result) {
	$sql .= "UPDATE activated_modules SET sort = '" . ($key+1) . "' WHERE id = '" . (int)$result['id'] . "'; ";
}	

$this->dbh->exec($sql);		
	
// обновляем сортировку меню

$menus = $this->dbh->query("SELECT * FROM menus ORDER BY id");

foreach ($menus as $menu) {
	count_menus_items_sort($menu['id'], 0, $this);
}

// 3. Удаляем не нужные директории
$remove_dirs = array(
	'/modules/modules',
	'/modules/components/components',
	'/modules/components/menus',
	'/modules/components/modules',
	'/modules/components/theme',
	'/modules/components/theme_catalog',
	'/modules/blocks/user_cms',
	'/modules/components/users/front_end',
	'/user_cms/modules/modules',
	'/user_cms/modules/components/components',
	'/user_cms/modules/components/menus',
	'/user_cms/modules/components/modules',
	'/user_cms/modules/components/theme',
	'/user_cms/modules/components/theme_catalog',
	'/user_cms/modules/blocks/user_cms',
	'/user_cms/modules/components/users/front_end',
);

foreach ($remove_dirs as $dir) {
	if (is_dir(ROOT_DIR . $dir)) {
		delTree(ROOT_DIR . $dir);
	}
}

// удаляем все старые install.php из папки user_cms
foreach (scandir(ROOT_DIR . '/user_cms') as $path) {
	if ($path != 'install.2.2.php_' && is_file(ROOT_DIR . '/user_cms/' . $path) && strpos($path, 'install') === 0) {
		unlink(ROOT_DIR . '/user_cms/' . $path);
	}
}


/*****************************************************************/

function delTree($dir) {
   $files = array_diff(scandir($dir), array('.','..'));
	foreach ($files as $file) {
	  (is_dir("$dir/$file")) ? delTree("$dir/$file") : unlink("$dir/$file");
	}
	return rmdir($dir);
}

function count_menus_items_sort($menu_id, $parent_id = 0, $obj) {
	if (!isset($sql)) {
		static $sql = '';
	}
	
	$results = $obj->dbh->query("SELECT * FROM menus_items WHERE parent_id = '" . (int)$parent_id . "' AND menu_id = '" . (int)$menu_id . "' ORDER BY sort ASC");
	
	foreach ($results as $key => $result) {
		$sql .= "UPDATE menus_items SET sort = '" . ($key+1) . "' WHERE id = '" . (int)$result['id'] . "'; ";
		
		count_menus_items_sort($menu_id, $result['id'], $obj);
	}
	
	if ($parent_id == 0) {
		if ($sql) {
			$res = $obj->dbh->exec($sql);
		}
		unset($sql);
		return $res;
	}
}
 ?>