<?php 

class module {
	
	public $data = array();
	
	function add_js($html) {
		return "\t\t<script type=\"text/javascript\">" . $html . "</script>\n";
	}
	function add_js_file($name) {
		return "\t\t<script type=\"text/javascript\" src=\"" . $name . "\"></script>\n";
	}
	function add_css($html) {
		return "\t\t<style type=\"text/css\">" . $html . "</style>\n";
	}
	function add_css_file($name) {
		return "\t\t<link rel=\"stylesheet\" type=\"text/css\" href=\"" . $name . "\">\n";
	}
	
	protected function load_helper($name) {
		$helper = 'helper_' . $name;
		if(file_exists(ROOT_DIR . '/user_cms/helpers/' . $helper . '.php')){
			require_once(ROOT_DIR . '/user_cms/helpers/' . $helper . '.php');
			$this->$helper = new $helper;
		}
	}
	
	protected function redirect($url, $status = 302) {
		header('Status: ' . $status);
		header('Location: ' . str_replace('&amp;', '&', $url));
		exit();
	}
	
	protected function get_component_config($component_name) {
		$ini_path = ROOT_DIR . '/modules/components/' . $component_name . '/back_end/component.ini';
		$config = array();
		
		if (file_exists($ini_path) && is_readable($ini_path)) {
			$results = parse_ini_file($ini_path, true);
			
			foreach ($results as $key => $result) {
				if (is_array($result) && isset($result['value'])) {
					$config[$key] = $result['value'];
				}
			}
		}
		
		return $config;
	}
	
}